Skip to main content
From the Cognite Console, you can upload a single 3D model to CDF without writing any code.

Before you start

To upload and process 3D models, you need an account with the 3d:create, files:write, and files:read capabilities for your CDF project. See Assign capabilities to learn more. You also need:
  • Your CDF project name. You will use this as the [projectname] below.
  • The file name(s) of the model(s) you will be uploading. You will use this as the [filename] below.

Upload 3D models

1

Create a model that can hold several revisions

curl -H "Authorization: Bearer <YOUR_OpenID Connect or OAuth2 token_HERE>" -H "Content-type: application/json" -X POST "https://api.cognitedata.com/api/v1/projects/[projectname]/3d/models" -d '{"items": [{"name":"model name"}]}'
API reference: Create 3D models
2

Copy and make a note of the id field

Copy and make a note of the id field in the response. You will use this as the [modelId] below.
3

Create a file placeholder to make the file available for processing later

curl -H "Authorization: Bearer <YOUR_OpenID Connect or OAuth2 token_HERE>" -H "Content-type: application/json" -X POST "https://api.cognitedata.com/api/v1/projects/[projectname]/files" -d '{"name":"[filename]"}'
API reference: Upload a file
4

Copy and make a note of the id field and uploadUrl

Copy and note the response id and uploadUrl. You will use them as [fileId] and [uploadUrl] in the next steps.
5

Upload the file

curl --upload-file [filename] [uploadUrl]
Google API reference: Perform resumable uploads
6

Create a versioned model and link the file from the first step to the revision

This also starts the processing of the model.
curl -H "Authorization: Bearer <YOUR_OpenID Connect or OAuth2 token_HERE>" -H "Content-type: application/json" -X POST "https://api.cognitedata.com/api/v1/projects/[projectname]/3d/models/[modelId]/revisions" -d '{"items": [{"fileId":"[fileId]"}]}'
API reference: Create 3D revisions
7

Monitor the processing of the model

API reference: Retrieve a 3D revision

Next steps

After uploading 3D models, you can add them to a scene to view and contextualize in CDF, or upload a revision to an existing model.
Last modified on April 10, 2026